Packager: Igor Vlasenko <viy@altlinux.ru>
%define _without_demo 1
BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}


%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repo    %{_javadir}/repository.jboss.com
%define repodir %{repo}/xdoclet/1.2.3-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define gcj_support 0

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}


# FIXME: JPP 1.7 lacks webwork and xwork, needed for the demo
%define with_demo 1

# If you do not want to build samples in demo subpackage because of their 
# runtime deps, give rpmbuild option '--without demo'
%define with_demo %{!?_without_demo:1}%{?_without_demo:0}
%define without_demo %{?_without_demo:1}%{!?_without_demo:0}

Name:           xdoclet
Version:        1.2.3
Release:        alt4_12jpp5
Epoch:          0
Summary:        XDoclet Attribute Orientated Programming Framework
# BSD-style, see <http://xdoclet.sourceforge.net/xdoclet/licenses/xdoclet-license.html>
License:        BSD
Group:          Development/Java
URL:            http://xdoclet.sourceforge.net
Source0:        %{name}-src-%{version}.tgz
Source1:        %{name}-modules-objectweb-4.6.tgz
Source2:        %{name}-component-info.xml
Patch0:         xdoclet-build_xml.patch
Patch1:         xdoclet-XDocletModulesEjbMessages.patch
Patch2:         xdoclet-ant.not-required.patch
Patch3:         xdoclet-WebLogicSubTask.patch
Patch4:         xdoclet-project_xml.patch
Patch5:         xdoclet-AbstractProgramElementTagsHandler.patch
Patch6:         xdoclet-build_docs_xml.patch
Patch7:         xdoclet-maven-plugin-project.patch
Patch8:         xdoclet-maven-plugin-template.patch
BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: ant >= 0:1.6
BuildRequires: ant-nodeps >= 0:1.5
BuildRequires: ant-trax
%if %{with_maven}
BuildRequires: maven1 >= 0:1.1
%endif
BuildRequires: junit
BuildRequires: javacc
BuildRequires: jrefactory
BuildRequires: bsf
BuildRequires: jakarta-commons-collections
BuildRequires: jakarta-commons-lang
BuildRequires: jakarta-commons-logging
BuildRequires: jakarta-commons-net
BuildRequires: log4j
BuildRequires: mockobjects >= 0:0.09-17
BuildRequires: struts
BuildRequires: velocity
BuildRequires: xalan-j2 >= 0:2.7.0
BuildRequires: xml-commons-apis
BuildRequires: xjavadoc >= 0:1.1
%if %{with_repolib}
BuildRequires: xjavadoc-repolib >= 0:1.1
%endif
Requires: bsf
Requires: jakarta-commons-collections
Requires: jakarta-commons-logging
Requires: log4j
Requires: mockobjects >= 0:0.09-17
Requires: velocity
Requires: xalan-j2 >= 0:2.7.0
Requires: xml-commons-apis
Requires: xjavadoc = 0:1.1
%if %{gcj_support}
BuildRequires: java-gcj-compat-devel
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif

%description
This package contains the XDoclet Attribute Orientated Programming Framework

%if %{with_demo}
%package demo
Summary:        XDoclet Sample Projects
Group:          Development/Java
BuildRequires: servletapi4
BuildRequires: struts
BuildRequires: velocity
BuildRequires: webwork >= 0:2.1
BuildRequires: xwork
BuildRequires: geronimo-ejb-2.1-api
BuildRequires: myfaces
BuildRequires: geronimo-jms-1.1-api
BuildRequires: mx4j
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: geronimo-ejb-2.1-api
Requires: myfaces
Requires: geronimo-jms-1.1-api
Requires: webwork
Requires: xwork
Requires: mx4j
Requires: struts
Requires: servletapi4
  

%description demo
This package contains sample XDoclet projects.
%endif

%if %{with_maven}
%package maven-plugin
Summary:        XDoclet Maven Plugin
Group:          Development/Java
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: maven1 >= 0:1.1

%description maven-plugin
%{summary}.
%endif

%package javadoc
Summary:        XDoclet Javadoc
Group:          Development/Documentation

%description javadoc
This package contains XDoclet javadoc

%package manual
Summary:        XDoclet Sample Manuals and Documentation
Group:          Development/Documentation

%description manual
This package contains XDoclet documentation.

%if %{with_repolib}
%package repolib
Summary:         Artifacts to be uploaded to a repository library
Group:           Development/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%prep
%setup -q
find . -name "*.jar" | xargs %{__rm}

# Replace JOnAS specific tasks with code blessed by ObjectWeb
# FIXME: (dwalluck) use %%setup here
pushd modules
mv objectweb objectweb.orig
tar xzf %{SOURCE1}
popd

for j in xjavadoc-1.1 jrefactory javacc junit bsf commons-collections commons-logging log4j velocity xalan-j2 xjavadoc xml-commons-apis mockobjects-core; do
        ln -s $(build-classpath $j) lib
done

%if %{with_demo}
for j in servletapi4 struts velocity webwork-migration xwork geronimo-ejb-2.1-api myfaces/myfaces-jsf-api geronimo-jms-1.1-api; do
        ln -s $(build-classpath $j) samples/lib
done
for j in mx4j/mx4j-jmx mx4j/mx4j-tools; do
        i=$(build-classpath $j)
        ln -s $(build-classpath $j) samples/lib
done
%endif

%patch0 -b .sav
%patch1 -b .sav
%patch2
%patch3 -b .sav
%patch4 -b .sav
%patch5 -b .sav
%patch6 -b .sav
%patch7
%patch8 -b .sav

%build
export CLASSPATH=$(build-classpath xalan-j2-serializer)
export MAVEN_HOME=%{_datadir}/maven
export MAVEN_LOCAL_HOME=$(pwd)/.maven
%if %{with_maven}
ant -Dant.build.javac.source=1.4 -Dant.build.javac.target=1.4 -Dbuild.sysclasspath=first core modules maven docs l10n
%else
ant -Dant.build.javac.source=1.4 -Dant.build.javac.target=1.4 -Dbuild.sysclasspath=first core modules docs l10n
%endif
%if %{with_demo}
ant -Dant.build.javac.source=1.4 -Dant.build.javac.target=1.4 samples
%endif

%install
mkdir -p $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 target/lib/xdoclet*.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
%if %{with_maven}
install -m 644 target/lib/maven-xdoclet*.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
%endif
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

%if %{with_demo}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -pr samples/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
%endif

mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
rm -rf target/docs/api

mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %{with_repolib}
        install -d -m 755 $RPM_BUILD_ROOT%{repodir}
        install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
        install -m 0644 %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml
        install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
        install -m 0644 %{PATCH1} $RPM_BUILD_ROOT%{repodirsrc}
        install -m 0644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
        install -m 0644 %{PATCH2} $RPM_BUILD_ROOT%{repodirsrc}
        install -m 0644 %{PATCH5} $RPM_BUILD_ROOT%{repodirsrc}
        cp -p $RPM_BUILD_ROOT%{_javadir}/xdoclet/xdoclet-jmx-module.jar $RPM_BUILD_ROOT%{repodirlib}
        cp -p $RPM_BUILD_ROOT%{_javadir}/xdoclet/xdoclet-web-module.jar $RPM_BUILD_ROOT%{repodirlib}
        cp -p $RPM_BUILD_ROOT%{_javadir}/xdoclet/xdoclet-java-module.jar $RPM_BUILD_ROOT%{repodirlib}
        cp -p $RPM_BUILD_ROOT%{_javadir}/xdoclet/xdoclet-portlet-module.jar $RPM_BUILD_ROOT%{repodirlib}
        cp -p $RPM_BUILD_ROOT%{_javadir}/xdoclet/xdoclet-jboss-module.jar $RPM_BUILD_ROOT%{repodirlib}
        cp -p $RPM_BUILD_ROOT%{_javadir}/xdoclet/xdoclet.jar $RPM_BUILD_ROOT%{repodirlib}
        cp -p %{repo}/xjavadoc/1.1-brew/lib/xjavadoc.jar $RPM_BUILD_ROOT%{repodirlib}
        cp -p $RPM_BUILD_ROOT%{_javadir}/xdoclet/xdoclet-hibernate-module.jar $RPM_BUILD_ROOT%{repodirlib}
        cp -p $RPM_BUILD_ROOT%{_javadir}/xdoclet/xdoclet-ejb-module.jar $RPM_BUILD_ROOT%{repodirlib}
        cp -p $RPM_BUILD_ROOT%{_javadir}/xdoclet/xdoclet-xdoclet-module.jar $RPM_BUILD_ROOT%{repodirlib}
%endif

%if %{gcj_support}
%{_bindir}/aot-compile-rpm --exclude %{_datadir}/%{name}-%{version}/target/classes
%endif

%files
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/%{name}*.jar
%doc LICENSE.txt
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/xdoclet-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-apache-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-bea-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-borland-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-caucho-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-ejb-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-exolab-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-hibernate-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-hp-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-ibm-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-java-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-jboss-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-jdo-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-jmx-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-jsf-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-libelis-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-macromedia-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-mockobjects-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-mvcsoft-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-mx4j-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-objectweb-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-openejb-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-oracle-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-orion-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-portlet-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-pramati-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-solarmetric-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-spring-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-sun-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-sybase-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-tjdo-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-web-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-webwork-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-wsee-module-1.2.3.jar.*
%{_libdir}/gcj/%{name}/xdoclet-xdoclet-module-1.2.3.jar.*
%endif

%if %{with_maven}
%files maven-plugin
%{_javadir}/%{name}/maven-%{name}*.jar
%endif

%if %{with_demo}
%files demo
%{_datadir}/%{name}-%{version}
%endif

%files javadoc
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files manual
%doc %{_docdir}/%{name}-%{version}

%if %{with_repolib}
%files repolib
%{repodir}
%endif

%changelog
* Mon Aug 29 2011 Igor Vlasenko <viy@altlinux.ru> 0:1.2.3-alt4_12jpp5
- maven1 dependency translaton

* Fri Mar 27 2009 Igor Vlasenko <viy@altlinux.ru> 0:1.2.3-alt3_12jpp5
- fixed repocop warnings

* Sun Jul 29 2007 Igor Vlasenko <viy@altlinux.ru> 0:1.2.3-alt3_9jpp1.7
- rebuilt with maven1

* Fri Jun 08 2007 Igor Vlasenko <viy@altlinux.ru> 0:1.2.3-alt2_9jpp1.7
- converted from JPackage by jppimport script

* Fri Jun 08 2007 Igor Vlasenko <viy@altlinux.ru> 0:1.2.3-alt1_9jpp1.7
- converted from JPackage by jppimport script

